# Generated by Django 3.0b1 on 2019-11-07 01:18

from django.db import migrations

import djstripe.fields


class Migration(migrations.Migration):

    dependencies = [
        ("djstripe", "0006_auto_20191005_0907"),
    ]

    operations = [
        migrations.AlterField(
            model_name="charge",
            name="amount",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                decimal_places=2,
                help_text="Amount charged (as decimal).",
                max_digits=11,
            ),
        ),
        migrations.AlterField(
            model_name="charge",
            name="amount_refunded",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                decimal_places=2,
                help_text="Amount (as decimal) refunded (can be less than the amount "
                "attribute on the charge if a partial refund was issued).",
                max_digits=11,
            ),
        ),
        migrations.AlterField(
            model_name="coupon",
            name="amount_off",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                blank=True,
                decimal_places=2,
                help_text="Amount (as decimal) that will be taken off the subtotal of "
                "any invoices for this customer.",
                max_digits=11,
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="invoice",
            name="amount_due",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                decimal_places=2,
                help_text="Final amount due (as decimal) at this time for this "
                "invoice. If the invoice's total is smaller than the minimum charge "
                "amount, for example, or if there is account credit that can be "
                "applied to the invoice, the amount_due may be 0. If there is a "
                "positive starting_balance for the invoice (the customer owes money), "
                "the amount_due will also take that into account. The charge that gets "
                "generated for the invoice will be for the amount specified in "
                "amount_due.",
                max_digits=11,
            ),
        ),
        migrations.AlterField(
            model_name="invoice",
            name="amount_paid",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                decimal_places=2,
                help_text="The amount, (as decimal), that was paid.",
                max_digits=11,
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="invoice",
            name="amount_remaining",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                decimal_places=2,
                help_text="The amount remaining, (as decimal), that is due.",
                max_digits=11,
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="invoice",
            name="application_fee_amount",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                blank=True,
                decimal_places=2,
                help_text="The fee (as decimal) that will be applied to the invoice "
                "and transferred to the application owner's Stripe account when the "
                "invoice is paid.",
                max_digits=11,
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="invoice",
            name="subtotal",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                decimal_places=2,
                help_text="Total (as decimal) of all subscriptions, invoice items, and "
                "prorations on the invoice before any discount or tax is applied.",
                max_digits=11,
            ),
        ),
        migrations.AlterField(
            model_name="invoice",
            name="tax",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                blank=True,
                decimal_places=2,
                help_text="The amount (as decimal) of tax included in the total, "
                "calculated from ``tax_percent`` and the subtotal. If no "
                "``tax_percent`` is defined, this value will be null.",
                max_digits=11,
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="invoice",
            name="total",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                decimal_places=2,
                max_digits=11,
                verbose_name="Total (as decimal) after discount.",
            ),
        ),
        migrations.AlterField(
            model_name="invoiceitem",
            name="amount",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                decimal_places=2,
                help_text="Amount invoiced (as decimal).",
                max_digits=11,
            ),
        ),
        migrations.AlterField(
            model_name="payout",
            name="amount",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                decimal_places=2,
                help_text="Amount (as decimal) to be transferred to your bank account "
                "or debit card.",
                max_digits=11,
            ),
        ),
        migrations.AlterField(
            model_name="plan",
            name="amount",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                blank=True,
                decimal_places=2,
                help_text="Amount (as decimal) to be charged on the interval "
                "specified.",
                max_digits=11,
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="source",
            name="amount",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                blank=True,
                decimal_places=2,
                help_text="Amount (as decimal) associated with the source. This is the "
                "amount for which the source will be chargeable once ready. Required "
                "for `single_use` sources.",
                max_digits=11,
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="transfer",
            name="amount",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                decimal_places=2, help_text="The amount transferred", max_digits=11
            ),
        ),
        migrations.AlterField(
            model_name="transfer",
            name="amount_reversed",
            field=djstripe.fields.StripeDecimalCurrencyAmountField(
                blank=True,
                decimal_places=2,
                help_text="The amount (as decimal) reversed (can be less than the "
                "amount attribute on the transfer if a partial reversal was issued).",
                max_digits=11,
                null=True,
            ),
        ),
    ]
